/*
 * Created on 18-okt-2003
 *
*/


import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.sql.ResultSet;
import java.util.Date;
import java.util.Map;
import java.util.Vector;

import junit.framework.Test;

import net.sf.hibernate.sql.Insert;

import org.aspectj.lang.reflect.SourceLocation;
import persistence.*;
import persistence.cache.Cache;
import persistence.table.TableComponent;
import persistence.type.ObjectID;
//import xdoclet.tagshandler.*;

/**
 * Logging aspect.
 * @author bram
 *
 * 18-okt-2003
 */
public aspect LogAspect {

	//monitor all executed SQL	
	pointcut SQLcode(String sqlCode):(call(public int java.sql.Statement.executeUpdate(String) throws java.sql.SQLException)||call(public ResultSet java.sql.Statement.executeQuery(String) throws java.sql.SQLException))&&args(sqlCode);

	before(String sqlCode): SQLcode(sqlCode) {		
		System.out.println("#"+thisJoinPoint.getSourceLocation().getWithinType().getName()+": line "+thisJoinPoint.getSourceLocation().getLine()+"\n\t"+sqlCode);
	}
	
	//monitor cache
	pointcut writeToCache(Cache cache):(call(public void persistence.cache.Cache.write*(..)))&&target(cache);
	
	after(Cache cache):writeToCache(cache){
		System.err.println(cache.toString());
	}
	
	
	
	


}
