/*
 * Created on 10-apr-2004
 *
*/
package aspects;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.Date;

import persistence.type.ConnectionFactory;
import persistence.type.ObjectID;

/**
 * Alle connecties in n persistente actie moeten dezelfde zijn om transacties toe te kunnen
 * laten.
 * @author bram
 *
 * 10-apr-2004
 */
public aspect ConnectionAspect percflow(PersistenceIntroducer.persistentExecution()){
	protected Connection connection=null;
	protected ConnectionFactory fac=new ConnectionFactory();	
	protected long id=(new Date()).getTime();
	protected int refCount=0;
	
	protected int getRefCount(){
		return refCount;
	}
	
	public Connection getConnection(){
		return connection;
	}
	
	public void closeConnection(){
		fac.closeConnection(connection);
	}
	
	declare precedence:ConnectionAspect,aspects.imp..*;//nodig om read-around goed te doen werken
	
	public ConnectionAspect(){
		System.out.println("CONSTRUCTOR ConnectionAspect");
	}
	
	//nodig om writes, ... met inheritance aan te kunnen
	//eventueel systeem-advies (cache, ...) mag niet gehinderd worden (zie implementorAdvice())
	void around():PersistenceIntroducer.writedeleteupdate()&&!cflow(PersistenceIntroducer.implementorAdvice()){
		System.out.println("Start van een write, delete of update ...");
		connection=fac.getConnection();
		proceed();
		fac.closeConnection(connection);
		System.out.println("Nu afsluiten van een write, delete of update ...");
		return;
	}
	
	//nodig om reads, ... met inheritance aan te kunnen
	//eventueel systeem-advies (cache, ...) mag niet gehinderd worden (zie implementorAdvice())
	Object around():PersistenceIntroducer.read()&&!cflow(PersistenceIntroducer.implementorAdvice()){
		System.out.println("Start van een read ...");
		connection=fac.getConnection();
		Object ob=proceed();
		fac.closeConnection(connection);
		System.out.println("Nu afsluiten van een read ...");
		return ob;
	}
	
	public pointcut connectionCreation():execution(public Connection persistence.type.ConnectionFactory.getConnection())&&cflow(PersistenceIntroducer.persistentExecution());//cflow(adviceexecution()&&within(aspects.*..*));//PersistenceIntroducer.implementorAdvice();//&&!cflow(within(aspects.*));//&&!within(aspects.*);
	Connection around():connectionCreation(){
		if(connection==null){
			System.out.println("@@@"+id+": Connection null; creating new one.");
			refCount=1;
			return proceed();				
		}else{
			try{
				if(connection.isClosed()){ 
					System.out.println("@@@"+id+": Connection closed; creating new one.");
					refCount=1;
					return proceed(); 
				}else{
					System.out.println("@@@"+id+": Connection reused.");
					refCount++;
					return connection;
				}
			}catch(SQLException ex){
				System.err.println("@@@"+id+": Hier nooit geraken; creating new one, but almost certainly trouble will follow!");
				refCount=1;
				return proceed();
			}
		}
	}
	
	public pointcut connectionClosing(Connection conn):execution(public void persistence.type.ConnectionFactory.closeConnection(java.sql.Connection))&&args(conn)&&cflow(PersistenceIntroducer.persistentExecution());//&&cflow(adviceexecution()&&within(aspects.*..*));//&&!cflow(within(aspects.*));
	void around(Connection conn):connectionClosing(conn){
		refCount--;
		if(refCount==0) proceed(conn);//nooit bereikt door extra closeConnection()
	}
	
}
