/*
 * Created on 20-mrt-2004
 *
*/
package aspects;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import persistence.Utilities;
import persistence.type.ConnectionFactory;
import persistence.type.ObjectIDFactory;

import net.sf.hibernate.sql.Select;

import com.sun.jdori.common.query.MyMemoryQuery;

/**
 * Voert opgebouwde queries volledig uit.
 * @author bram
 *
 * 20-mrt-2004
 */
public privileged aspect QueryAspect {
	pointcut executeSQL(
		com.sun.jdori.query.Node node,
		MyMemoryQuery mem) : PersistenceIntroducer
		.walk()
		&& args(node, mem)
		&& withincode(
			public Collection com
				.sun
				.jdori
				.common
				.query
				.QueryResultHelperImpl
				.applyFilter());

	//noodzakelijk around: i.p.v. een SQL-String moet het een collectie van ObjectID's worden	
	Object around(
		com.sun.jdori.query.Node node,
		MyMemoryQuery mem) : executeSQL(
		node,
		mem) {
		Object ob = proceed(node, mem);//gecreerde SQL-query, het WHERE-gedeelte; rest nu assembleren
		System.out.println("In executeSQL!!!");
		Collection res = new ArrayList();
		Select select = new Select();

		Collection outerFromClauses = new ArrayList();
		Iterator it = mem.outerJoins.keySet().iterator();
		while (it.hasNext()) {
			String alias1 = (String) it.next();
			String table1 = (String) mem.aliasToTableMapping.get(alias1);
			Vector vec = (Vector) mem.outerJoins.get(alias1);
			String alias2 = (String) vec.get(0);
			String table2 = (String) mem.aliasToTableMapping.get(alias2);
			String condition = (String) vec.get(1);
			outerFromClauses.add(
				table1
					+ " "
					+ alias1
					+ " left outer join "
					+ table2
					+ " "
					+ alias2
					+ " on "
					+ condition);
		}
		select.setOuterJoins(
			Utilities.fillIn(outerFromClauses, ", ", false),
			"");

		select.setSelectClause(
			"distinct "
				+ (String) mem.nameToAliasMapping.get("this")
				+ ".$OID$");

		select.setWhereClause(
			Utilities.fillIn(mem.joinSet, " AND ", true) + (String) ob);

		String orderBy = Utilities.fillIn(mem.orderByClause, ", ", false);
		if (!orderBy.equals(""))
			select.setOrderByClause(
				orderBy
					+ " having "
					+ Utilities.fillIn(mem.havingClause, ", ", false));

		Collection allAliases = mem.aliasToTableMapping.keySet();
		it = allAliases.iterator();
		Collection tmp = new ArrayList();
		while (it.hasNext()) {
			String temp = (String) it.next();
			tmp.add(temp);
		}
		tmp.removeAll(mem.outerJoinAliases); //enkel inner joins over
		select.setFromClause("dummy");
		//nodig voor uitfilteren overbodige aliassen
		String temporarySQL = select.toStatementString();
		it = tmp.iterator();
		Collection tmp2 = new ArrayList();
		while (it.hasNext()) {
			String alias = (String) it.next();
			if (temporarySQL.matches(".*" + alias + ".*"))
				tmp2.add(alias);
		}
		Collection innerFromClauses = new ArrayList();
		it = tmp2.iterator();
		while (it.hasNext()) {
			String alias = (String) it.next();
			String table = (String) mem.aliasToTableMapping.get(alias);
			innerFromClauses.add(table + " " + alias);
		}
		boolean out = (mem.outerJoins.keySet().size() == 0) ? false : true;
		select.setFromClause(Utilities.fillIn(innerFromClauses, ", ", out));

		System.out.println(select.toStatementString());

		//resulterende OID's reconstrueren en in res steken	
		ConnectionFactory fab = new ConnectionFactory();
		Connection connec = fab.getConnection();
		try {			
			Statement stmt = null;
			ResultSet result = null;
			stmt = connec.createStatement();
			result = stmt.executeQuery(select.toStatementString());
			while (result.next()) {
				ObjectIDFactory facc = new ObjectIDFactory();
				res.add(facc.translateToObjectID(result.getString(1)));
			}			
		} catch (Exception e) {
		} finally {
			fab.closeConnection(connec);
		}

		return res;//Collection van ObjectID's van goeie objecten
	}
}
