/*
 * Created on 23-mrt-2004
 *
*/
package aspects;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Voorziet rudimentaire transacties.
 * @author bram
 *
 * 23-mrt-2004
 */
public privileged aspect TransactionAspect percflow(PersistenceIntroducer.persistentExecution()){
	/**
	 * Constructor
	 */
	public TransactionAspect(){
		System.out.println("CONSTRUCTOR van TransactionAspect");
	}
	
	//Transactions depend on the acquired connections.
	declare precedence:ConnectionAspect,TransactionAspect;
	
	/**
	 * Open transaction bij eerste connectie 
	 */
	after() returning(Connection conn):ConnectionAspect.connectionCreation(){
		try{
			conn.setAutoCommit(false);
			System.out.println("###"+aspects.ConnectionAspect.aspectOf().id+": transactie OPEN");
		}catch(SQLException ex){
			System.err.println("###"+aspects.ConnectionAspect.aspectOf().id+": transactie OPEN MISLUKT");
			ex.printStackTrace();
		}
	}
	
	//problemen met JDOQueryException?
	after() throwing:PersistenceIntroducer.persistentExecution()&&within(!aspects.imp.*){
		try{
		    aspects.ConnectionAspect.aspectOf().getConnection().rollback();
		    System.out.println("###"+aspects.ConnectionAspect.aspectOf().id+": transactie ROLLBACK");
		}catch(SQLException ex){
		    System.err.println("###"+aspects.ConnectionAspect.aspectOf().id+": transactie ROLLBACK MISLUKT");
		    ex.printStackTrace();
		}
		aspects.ConnectionAspect.aspectOf().closeConnection();
	}
	
	before(Connection conn):ConnectionAspect.connectionClosing(conn){
		try{
		    conn.setAutoCommit(true);
			System.out.println("###"+aspects.ConnectionAspect.aspectOf().id+": transactie CLOSED");
		}catch(SQLException ex){
			System.err.println("###"+aspects.ConnectionAspect.aspectOf().id+": transactie CLOSED MISLUKT ... ROLLBACKING ...");
			ex.printStackTrace();
			try{
			    conn.rollback();
			}catch(Exception e){
				System.err.println("###"+aspects.ConnectionAspect.aspectOf().id+": ROLLBACKING MISLUKT");
				e.printStackTrace();
			}						
		}	
	}

}
