package doclet;

import persistence.Utilities;
import java.util.Map;
import java.util.Collection;
import java.util.Iterator;

/**
 * Automatisch gegenereerd door JET om klassenlijsten te kunnen genereren.
 */
public class ClassFileGenerator {
  protected final String NL = System.getProperties().getProperty("line.separator");
  protected final String TEXT_1 = "<?xml version=\"1.0\" ?>" + NL + "<root>";
  protected final String TEXT_2 = NL + "\t<classUnit name=\"";
  protected final String TEXT_3 = "\">";
  protected final String TEXT_4 = NL + "\t\t<interface role=\"container\">";
  protected final String TEXT_5 = "</interface>";
  protected final String TEXT_6 = NL + "\t\t<class role=\"container\">";
  protected final String TEXT_7 = "</class>";
  protected final String TEXT_8 = NL + "\t\t<interface role=\"";
  protected final String TEXT_9 = "\">";
  protected final String TEXT_10 = "</interface>";
  protected final String TEXT_11 = "\t\t\t" + NL + "\t\t<class role=\"";
  protected final String TEXT_12 = "\">";
  protected final String TEXT_13 = "</class>";
  protected final String TEXT_14 = NL + "\t</classUnit>";
  protected final String TEXT_15 = NL + "</root>";

	private Map containerMap=null;
	
	public void setContainerMap(Map containerMap){
		this.containerMap=containerMap;
	}

     /**
	 * Generate class file.
	 * @param argument Map van names containers naar alle inners
	 * @return
	 */
    public String generate(Object argument)
  {
    StringBuffer stringBuffer = new StringBuffer();
    stringBuffer.append(TEXT_1);
    
	//creatie klassenlijst
	Iterator it=containerMap.keySet().iterator();
	while(it.hasNext()){
		String typeName=(String)it.next();
		Collection col=(Collection)containerMap.get(typeName);
		Class cla=null;		
		try{
			cla=Class.forName(typeName);
		}catch(Exception ex){
			try{
				cla=Class.forName(Utilities.checkClassName(typeName));
			}catch(Exception e){
				System.err.println("Er zouden al eerder foutmeldingen geweest moeten zijn!");
			}
		}
	
    stringBuffer.append(TEXT_2);
    stringBuffer.append( typeName );
    stringBuffer.append(TEXT_3);
    
		if(cla.isInterface()){
    stringBuffer.append(TEXT_4);
    stringBuffer.append( typeName );
    stringBuffer.append(TEXT_5);
    
		}else{
    stringBuffer.append(TEXT_6);
    stringBuffer.append( typeName );
    stringBuffer.append(TEXT_7);
    
		}
		Iterator at=col.iterator();
		while(at.hasNext()){
			String innerName=(String)at.next();
			boolean nested=false;

			try{
				cla=Class.forName(innerName);
				nested=Utilities.isNested(cla);
			}catch(Exception ex){
				try{
					cla=Class.forName(Utilities.checkClassName(innerName));
					nested=Utilities.isNested(cla);
				}catch(Exception e){}//zeker false laten
			}
			if(cla.isInterface()){
    stringBuffer.append(TEXT_8);
    stringBuffer.append( (nested)?"nested":"inner" );
    stringBuffer.append(TEXT_9);
    stringBuffer.append( innerName );
    stringBuffer.append(TEXT_10);
    
			}else{
    stringBuffer.append(TEXT_11);
    stringBuffer.append( (nested)?"nested":"inner" );
    stringBuffer.append(TEXT_12);
    stringBuffer.append( innerName );
    stringBuffer.append(TEXT_13);
    
			}			
		}
    stringBuffer.append(TEXT_14);
    
	}

    stringBuffer.append(TEXT_15);
    return stringBuffer.toString();
  }
}