package doclet;

import persistence.Utilities;
import com.sun.javadoc.*;
import java.util.Map;
import java.util.HashMap;
import doclet.TagException;
import java.util.Iterator;
import java.util.ArrayList;
import java.lang.reflect.Modifier;

/**
 * Automatisch gegenereerd door JET om <persistentClass/Interface>-tags van 
 * persistentiebestand voor bepaalde klasse/interface te creren.
 */
public class XMLDoclet {	

  protected final String NL = System.getProperties().getProperty("line.separator");
  protected final String TEXT_1 = NL + "<persistentInterface name=\"";
  protected final String TEXT_2 = "\" role=\"";
  protected final String TEXT_3 = "\"/>" + NL;
  protected final String TEXT_4 = NL + "<persistentClass name=\"";
  protected final String TEXT_5 = "\" extends=\"";
  protected final String TEXT_6 = "\" role=\"";
  protected final String TEXT_7 = "\">" + NL + "\t<db database=";
  protected final String TEXT_8 = " table=";
  protected final String TEXT_9 = "/>";
  protected final String TEXT_10 = NL + "\t<pversion major=";
  protected final String TEXT_11 = " minor=";
  protected final String TEXT_12 = "/>";
  protected final String TEXT_13 = NL + "\t<persistentAttribute name=\"";
  protected final String TEXT_14 = "\" accessor=\"";
  protected final String TEXT_15 = "\" index=\"";
  protected final String TEXT_16 = "\">";
  protected final String TEXT_17 = NL + "\t\t<get>";
  protected final String TEXT_18 = "</get>" + NL + "\t\t<set>";
  protected final String TEXT_19 = "</set>";
  protected final String TEXT_20 = NL + "\t\t<content array=\"";
  protected final String TEXT_21 = "\" compType=";
  protected final String TEXT_22 = " ";
  protected final String TEXT_23 = " size=";
  protected final String TEXT_24 = " compTypeKey=";
  protected final String TEXT_25 = " sizeKey=";
  protected final String TEXT_26 = " impClassKey=";
  protected final String TEXT_27 = " containedKey=";
  protected final String TEXT_28 = "/>";
  protected final String TEXT_29 = NL + "\t\t<content array=\"";
  protected final String TEXT_30 = "\" compType=";
  protected final String TEXT_31 = " impClass=";
  protected final String TEXT_32 = " contained=";
  protected final String TEXT_33 = " compTypeKey=";
  protected final String TEXT_34 = " sizeKey=";
  protected final String TEXT_35 = " impClassKey=";
  protected final String TEXT_36 = " containedKey=";
  protected final String TEXT_37 = "/>";
  protected final String TEXT_38 = NL + "\t\t<content compType=";
  protected final String TEXT_39 = " size=";
  protected final String TEXT_40 = " compTypeKey=";
  protected final String TEXT_41 = " sizeKey=";
  protected final String TEXT_42 = " impClassKey=\"";
  protected final String TEXT_43 = "\"";
  protected final String TEXT_44 = " containedKey=";
  protected final String TEXT_45 = "/>";
  protected final String TEXT_46 = NL + "\t\t<content compType=";
  protected final String TEXT_47 = " ";
  protected final String TEXT_48 = " impClass=";
  protected final String TEXT_49 = " contained=";
  protected final String TEXT_50 = " compTypeKey=";
  protected final String TEXT_51 = " sizeKey=";
  protected final String TEXT_52 = " impClassKey=";
  protected final String TEXT_53 = " containedKey=";
  protected final String TEXT_54 = "/>";
  protected final String TEXT_55 = NL + "\t\t";
  protected final String TEXT_56 = NL + "\t</persistentAttribute>";
  protected final String TEXT_57 = NL + "</persistentClass>";

	/**
	 * Extract correctly provided attributes of given tag.
	 * @param tag
	 * @return
	 */
    private Map getAttributes(Tag tag){
    	Map res=new HashMap();
    	String content=tag.text();
    	String[] expressions=content.split("\\s");
    	for(int i=0;i<expressions.length;i++){
    		if(expressions[i].indexOf('=')!=-1){
	    		String[] parts=expressions[i].split("=");
    			System.out.println("part 0: "+parts[0]);
				System.out.println("part 1: "+parts[1]);
    			res.put(parts[0],parts[1]);
    		}
    	}
    	return res;
    }
              
  /**
  * Zoek impClass.
  * @param currentField
  * @return
  * @throws TagException
  */
 private String getImpClass(FieldDoc currentField,String tag) throws TagException{
 		String impClass="";		
 		Type currentType=currentField.type();
		if((currentType.asClassDoc()!=null)&&(currentType.asClassDoc().isAbstract())){ //short-circuit!!!
			Map impClassMap=getAttributes(currentField.tags(tag)[0]);
			String tmp=(String)impClassMap.get("impClass");
			impClass = getImpClass(currentType.qualifiedTypeName(), tmp,currentType.asClassDoc().isInterface());
		} //if-abstract
		return impClass;
 }
 
/**
 * Interprete impClass-attribute for currentType, ONLY useful for abstract types!!!
 * @param currentType
 * @param impClassTag
 * @param isInterface otherwise abstract class
 * @return
 * @throws TagException
 */    
private String getImpClass(String currentType, String impClassTag,boolean isInterface)
	throws TagException {
	String impClass=impClassTag;
	if(impClass==null){ //no implementation provided
		if(Utilities.isCollection(currentType)){
			impClass="\"java.util.ArrayList\"";
		}else{
			if(Utilities.isMap(currentType)){
				impClass="\"java.util.HashMap\"";					
			}else{ //no implementation provided for not-Collection/Map
				//er wordt in metadata.xmljet nog eens gecontroleerd of werk hier wel gedaan
				//zie de 4 TagException's (2X value en 2X key)					
				if(isInterface) impClass="\"unknown implementor\"";
				else impClass="\"unknown extender\"";
			}
		}
	}else{
		try{
			Class cla=Class.forName(Utilities.removeAanhalingsTekens(impClass));
			if(cla.isInterface()||Modifier.isAbstract(cla.getModifiers())) impClass="";
		} catch (ClassNotFoundException e) {
			impClass="";
		}
	}
	return impClass;
}    

	/**
	 * Generate part of xml-file belonging to specific class.
	 * @param argument
	 * @return
	 * @throws TagException wrong tagging
	 */
    public String generate(Object argument) throws TagException
  {
    StringBuffer stringBuffer = new StringBuffer();
    
//creatie <persistentClass/Interface>-tags van persistentiebestand voor bepaalde klasse/interface
ClassDoc classDoc=(ClassDoc)argument;
Tag[] dbTags=classDoc.tags("@db");
String db_database="\"\"";
String db_table="\"\"";
Map dbMap=null;
if(dbTags.length!=0){
	dbMap=getAttributes(dbTags[0]);
	String database=(String)dbMap.get("database");	
	String table=(String)dbMap.get("table");
	db_database=(database==null)?"\"\"":database;
	db_table=(table==null)?"\"\"":table;	
}
Class persCla=null;
String className=classDoc.qualifiedName();
try{
	persCla=Class.forName(className);
}catch(Exception e){
	try{
		persCla=Class.forName(Utilities.checkClassName(className));
	}catch(Exception ex){
		throw new TagException("Could not load class "+className+"!");
	}
}
if(classDoc.isInterface()){

    stringBuffer.append(TEXT_1);
    stringBuffer.append( className );
    stringBuffer.append(TEXT_2);
    stringBuffer.append( (Utilities.isInner(persCla))?"inner":((Utilities.isNested(persCla))?"nested":"container") );
    stringBuffer.append(TEXT_3);
    
}else{

    stringBuffer.append(TEXT_4);
    stringBuffer.append( className );
    stringBuffer.append(TEXT_5);
    stringBuffer.append( classDoc.superclass().qualifiedName());
    stringBuffer.append(TEXT_6);
    stringBuffer.append( (Utilities.isInner(persCla))?"inner":((Utilities.isNested(persCla))?"nested":"container") );
    stringBuffer.append(TEXT_7);
    stringBuffer.append( db_database );
    stringBuffer.append(TEXT_8);
    stringBuffer.append( db_table );
    stringBuffer.append(TEXT_9);
    
	Tag[] versionTags=classDoc.tags("@pversion");

	Map versionMap=getAttributes(versionTags[0]);
	String major=(String)versionMap.get("major");	
	String minor=(String)versionMap.get("minor");
	String version_major=(major==null)?"":major;
	String version_minor=(minor==null)?"\"0\"":minor;	
	
    stringBuffer.append(TEXT_10);
    stringBuffer.append( version_major );
    stringBuffer.append(TEXT_11);
    stringBuffer.append( version_minor );
    stringBuffer.append(TEXT_12);
    
	FieldDoc[] fields=classDoc.fields();
	for(int i=0;i<fields.length;i++){
		FieldDoc currentField=fields[i];
		Type currentType=currentField.type();
		//enkel niet-transient, niet-volatile en @persistent-attributen bekijken!
		if(currentField.isTransient()||currentField.isVolatile()||(currentField.tags("@persistent").length==0)) continue;		
		Tag[] accessorTag=currentField.tags("@accessor");		
		String accessor=(accessorTag.length==0)?"false":"true";		
		Tag[] indexTag=currentField.tags("@index");		
		String indexx=(indexTag.length==0)?"false":"true";
	
    stringBuffer.append(TEXT_13);
    stringBuffer.append( currentField.name() );
    stringBuffer.append(TEXT_14);
    stringBuffer.append( accessor );
    stringBuffer.append(TEXT_15);
    stringBuffer.append( indexx );
    stringBuffer.append(TEXT_16);
    
		Tag[] getTag=currentField.tags("@get");
		Tag[] setTag=currentField.tags("@set");
		String compType="\""+currentType.qualifiedTypeName()+currentType.dimension()+"\"";		
		String get=(getTag.length==0)?Utilities.constructGetter(currentField.name(),compType):getTag[0].text();
		String set=(setTag.length==0)?Utilities.constructSetter(currentField.name()):setTag[0].text();
		
    stringBuffer.append(TEXT_17);
    stringBuffer.append( get );
    stringBuffer.append(TEXT_18);
    stringBuffer.append( set );
    stringBuffer.append(TEXT_19);
    				
		ArrayList tagsToDo=new ArrayList();//contains all content tag info
		Tag[] leftTags=currentField.tags("@content");
		for(int j=0;j<leftTags.length;j++){
			tagsToDo.add(getAttributes(leftTags[j]));
		}
		//compType bevat aanhalingstekens!!!!!!!!!
		//String compType="\""+currentType.qualifiedTypeName()+currentType.dimension()+"\"";
		leftTags=currentField.tags("@persistent");
		Map tmpMap=getAttributes(leftTags[0]);
		String tmp=(String)tmpMap.get("contained");
		if((tmp!=null)&&!(tmp.equals("\"false\"")||tmp.equals("\"uni\"")||tmp.equals("\"bi\""))) throw new TagException("Wrong value for contained-tag attribute at attribute "+currentField.qualifiedName());
		String contained=(tmp==null)?"":tmp;
		tmp=(String)tmpMap.get("containedKey");
		String containedKey=(tmp==null)?"":tmp;
		tmp=(String)tmpMap.get("compTypeKey");				
		String compTypeKey="\"\"";
		tmp=(String)tmpMap.get("impClass");				
		String impClass="";
		boolean isInterface=false;
		boolean isInterfaceKey=false;//pas in loop nodig
		try{
			Class cla=Class.forName(currentType.qualifiedTypeName());//als array, dan zonder dimensie
			isInterface=cla.isInterface();
			if(isInterface||Modifier.isAbstract(cla.getModifiers())) impClass=getImpClass(currentType.qualifiedTypeName(),tmp,isInterface);
		}catch(ClassNotFoundException ex){ //kan geen kwaad
		}
		String size=(String)tmpMap.get("size");		
		String impClassKey="";
		String prevCompType="";
		String sizeKey=null;

		Iterator it=tagsToDo.iterator();
		int aantal=tagsToDo.size()+1;
		int index=0;//used for avoiding infinite loop (see while(...(index<100)))
		do{
			index++;
			if(compType.indexOf('[')!=-1){ //array
				String compTypeType=compType.substring(0,compType.indexOf('['))+"\"";
				String compTypeDim=compType.substring(compType.indexOf('['),compType.length()-1);//geen \"s				
				if(Utilities.isPrimitive(compTypeType)){
		
    stringBuffer.append(TEXT_20);
    stringBuffer.append( Utilities.getDimension(compTypeDim) );
    stringBuffer.append(TEXT_21);
    stringBuffer.append( compTypeType );
    stringBuffer.append(TEXT_22);
     if(compTypeType.equals("\"java.lang.String\"")){ 
    stringBuffer.append(TEXT_23);
    stringBuffer.append( (size==null)?"\"256\"":size );
    }
     if((!prevCompType.equals(""))&&Utilities.isMap(prevCompType)){ 
    stringBuffer.append(TEXT_24);
    stringBuffer.append( compTypeKey );
     if(compTypeKey.equals("\"java.lang.String\"")){
    stringBuffer.append(TEXT_25);
    stringBuffer.append( (sizeKey==null)?"\"256\"":sizeKey );
    }
     if(!impClassKey.equals("")){
    stringBuffer.append(TEXT_26);
    stringBuffer.append( impClassKey );
    }
     if((!Utilities.isPrimitive(compTypeKey))&&(!Utilities.isMap(compTypeKey))&&(!Utilities.isCollection(compTypeKey))){
    stringBuffer.append(TEXT_27);
    stringBuffer.append( (containedKey.equals(""))?"\"false\"":containedKey );
    }
    }
    stringBuffer.append(TEXT_28);
    
				}else{ //not primitive array										
		
    stringBuffer.append(TEXT_29);
    stringBuffer.append( Utilities.getDimension(compTypeDim) );
    stringBuffer.append(TEXT_30);
    stringBuffer.append( compTypeType );
     if(!impClass.equals("")){
    stringBuffer.append(TEXT_31);
    stringBuffer.append( impClass );
    }else if(isInterface){throw new TagException(compTypeType+"heeft impClass-tag attribuut nodig!");}
     if(!(Utilities.isCollection(compTypeType)||Utilities.isMap(compTypeType))){ 
    stringBuffer.append(TEXT_32);
    stringBuffer.append( (contained.equals(""))?"\"false\"":contained );
    }
     if((!prevCompType.equals(""))&&Utilities.isMap(prevCompType)){ 
    stringBuffer.append(TEXT_33);
    stringBuffer.append( compTypeKey );
     if(compTypeKey.equals("\"java.lang.String\"")){
    stringBuffer.append(TEXT_34);
    stringBuffer.append( (sizeKey==null)?"\"256\"":sizeKey );
    }
     if(!impClassKey.equals("")){
    stringBuffer.append(TEXT_35);
    stringBuffer.append( impClassKey );
    }else if(isInterfaceKey){throw new TagException(compTypeKey+"heeft impClassKey-tag attribuut nodig!");}
     if((!Utilities.isPrimitive(compTypeKey))&&(!Utilities.isMap(compTypeKey))&&(!Utilities.isCollection(compTypeKey))){
    stringBuffer.append(TEXT_36);
    stringBuffer.append( (containedKey.equals(""))?"\"false\"":containedKey );
    }
    }
    stringBuffer.append(TEXT_37);
    
				}
				if((!Utilities.isPrimitive(compTypeType))&&(Utilities.isCollection(compTypeType)||Utilities.isMap(compTypeType))) prevCompType=compTypeType;
				else prevCompType="";
				//DEBUG//System.err.println("compTypeType: "+compTypeType+" <--> prevCompType: "+prevCompType);				
			}else{ //no array
				if(Utilities.isPrimitive(compType)){
					if((!prevCompType.equals(""))&&Utilities.isRealPrimitive(compType)&&(Utilities.isCollection(prevCompType)||Utilities.isMap(prevCompType))) throw new TagException("compType has to be an Object, not a primitive!!!");
		
    stringBuffer.append(TEXT_38);
    stringBuffer.append( compType );
     if(compType.equals("\"java.lang.String\"")){ 
    stringBuffer.append(TEXT_39);
    stringBuffer.append( (size==null)?"\"256\"":size );
    }
     if((!prevCompType.equals(""))&&Utilities.isMap(prevCompType)){ 
    stringBuffer.append(TEXT_40);
    stringBuffer.append( compTypeKey );
     if(compTypeKey.equals("\"java.lang.String\"")){
    stringBuffer.append(TEXT_41);
    stringBuffer.append( (sizeKey==null)?"\"256\"":sizeKey );
    }
     if(!impClassKey.equals("")){
    stringBuffer.append(TEXT_42);
    stringBuffer.append( impClassKey );
    stringBuffer.append(TEXT_43);
    }
     if((!Utilities.isPrimitive(compTypeKey))&&(!Utilities.isMap(compTypeKey))&&(!Utilities.isCollection(compTypeKey))){
    stringBuffer.append(TEXT_44);
    stringBuffer.append( (containedKey.equals(""))?"\"false\"":containedKey );
    }
    }
    stringBuffer.append(TEXT_45);
    
				}else{ //not primitive							
		
    stringBuffer.append(TEXT_46);
    stringBuffer.append( compType );
    stringBuffer.append(TEXT_47);
     if(!impClass.equals("")){
    stringBuffer.append(TEXT_48);
    stringBuffer.append( impClass );
    }else if(isInterface){throw new TagException(compType+"heeft impClass-tag attribuut nodig!");}
     if(!(Utilities.isCollection(compType)||Utilities.isMap(compType))){ 
    stringBuffer.append(TEXT_49);
    stringBuffer.append( (contained.equals(""))?"\"false\"":contained );
    }
     if((!prevCompType.equals(""))&&Utilities.isMap(prevCompType)){ 
    stringBuffer.append(TEXT_50);
    stringBuffer.append( compTypeKey );
     if(compTypeKey.equals("\"java.lang.String\"")){
    stringBuffer.append(TEXT_51);
    stringBuffer.append( (sizeKey==null)?"\"256\"":sizeKey );
    }
     if(!impClassKey.equals("")){
    stringBuffer.append(TEXT_52);
    stringBuffer.append( impClassKey );
    }else if(isInterfaceKey){throw new TagException(compTypeKey+"heeft impClassKey-tag attribuut nodig!");}
     if((!Utilities.isPrimitive(compTypeKey))&&(!Utilities.isMap(compTypeKey))&&(!Utilities.isCollection(compTypeKey))){
    stringBuffer.append(TEXT_53);
    stringBuffer.append( (containedKey.equals(""))?"\"false\"":containedKey );
    }
    }
    stringBuffer.append(TEXT_54);
    
				}

				if((!Utilities.isPrimitive(compType))&&(Utilities.isCollection(compType)||Utilities.isMap(compType))) prevCompType=compType;
				else prevCompType="";
				//DEBUG//System.err.println("compType: "+compType+" <--> prevCompType: "+prevCompType);
			}

			

			if(it.hasNext()){
				Map currentTag=(Map)it.next();
				tmp=(String)currentTag.get("compType");
				compType=(tmp==null)?"\"\"":tmp;
				size=(String)currentTag.get("size");
				tmp=(String)currentTag.get("contained");
				if((tmp!=null)&&!(tmp.equals("\"false\"")||tmp.equals("\"uni\"")||tmp.equals("\"bi\""))) throw new TagException("Wrong value for contained-tag attribute at attribute "+currentField.qualifiedName());
				contained=(tmp==null)?"":tmp;
				tmp=(String)currentTag.get("containedKey");
				containedKey=(tmp==null)?"":tmp;
				tmp=(String)currentTag.get("compTypeKey");				
				compTypeKey=(tmp==null)?"\"\"":tmp;
				if((!compTypeKey.equals("\"\""))&&Utilities.isRealPrimitive(compTypeKey)) throw new TagException("compTypeKey has to be an Object, not a primitive!!!");
				sizeKey=(String)currentTag.get("sizeKey");
				tmp=(String)currentTag.get("impClass");				
				impClass="";
				try{
					int pos=compType.indexOf('[');
					String compTypeWithoutBrackets=(pos==-1)?compType:compType.substring(0,pos)+"\"";
					Class cla=Class.forName(Utilities.removeAanhalingsTekens(compTypeWithoutBrackets));
					isInterface=cla.isInterface();
					if(isInterface||Modifier.isAbstract(cla.getModifiers())) impClass=getImpClass(compTypeWithoutBrackets,tmp,isInterface);
				}catch(ClassNotFoundException ex){ //kan geen kwaad
				}
				impClassKey="";
				try{
					//geen arrays mogelijk als key, dus compTypeKey zonder meer bruikbaar
					Class cla=Class.forName(Utilities.removeAanhalingsTekens(compTypeKey));
					isInterfaceKey=cla.isInterface();
					if(isInterfaceKey||Modifier.isAbstract(cla.getModifiers())) impClassKey=getImpClass(compTypeKey,tmp,isInterfaceKey);
				}catch(ClassNotFoundException ex){ //kan geen kwaad
				}		
			} //if-next			
		}while((!prevCompType.equals(""))&&(index<100)); //while
    stringBuffer.append(TEXT_55);
    
		//} //if-Map/array/Collection
    stringBuffer.append(TEXT_56);
    
	} //for
	
    stringBuffer.append(TEXT_57);
    
}
    return stringBuffer.toString();
  }
}