package persistence.script;

import java.util.*;
import java.io.*;
import persistence.AbstractSQLFactory.Registry;

public class DBScript {	
  protected final String NL = System.getProperties().getProperty("line.separator");
  protected final String TEXT_1 = "import java.io.BufferedInputStream;" + NL + "import java.io.FileInputStream;" + NL + "import java.io.FileNotFoundException;" + NL + "import java.io.IOException;" + NL + "import java.io.InputStream;" + NL + "import java.sql.Connection;" + NL + "import java.sql.SQLException;" + NL + "import java.sql.Statement;" + NL + "import java.util.Properties;" + NL + "" + NL + "import net.sf.hibernate.HibernateException;" + NL + "import net.sf.hibernate.dialect.Dialect;" + NL + "" + NL + "import persistence.DatabaseConnection;" + NL + "" + NL + "public class Script{" + NL + "\tprivate static Connection conn=null;" + NL + "\tprivate static Dialect _d_i_a_l_e_c_t_=null;" + NL + "" + NL + "\tpublic static void main(String argv []){" + NL + "\t\tProperties props=new Properties();" + NL + "\t\ttry {" + NL + "\t\t\t\t\t\tInputStream in=new BufferedInputStream(new FileInputStream(\"./db.properties\"));" + NL + "\t\t\t\t\t\tprops.load(in);" + NL + "\t\t\t\t\t\tconn=(new DatabaseConnection(props)).getConn();" + NL + "\t\t\t\t\t\t_d_i_a_l_e_c_t_=Dialect.getDialect(props);" + NL + "\t\t} catch (ClassNotFoundException e) {\t\t\t" + NL + "\t\t\te.printStackTrace();" + NL + "\t\t} catch (SQLException e) {\t\t\t" + NL + "\t\t\te.printStackTrace();" + NL + "\t\t} catch (FileNotFoundException e) {\t\t\t" + NL + "\t\t\te.printStackTrace();" + NL + "\t\t} catch (IOException e) {\t\t\t" + NL + "\t\t\te.printStackTrace();" + NL + "\t\t} catch(HibernateException e){" + NL + "\t\t\te.printStackTrace();" + NL + "\t\t}" + NL + "\t\tSystem.out.println(\"Drop oude versie\");" + NL + "\t\tdrop();" + NL + "\t\tSystem.out.println(\"Create nieuwe versie\");" + NL + "\t\tcreate();" + NL + "\t}" + NL + "\t" + NL + "\tpublic static void create(){\t" + NL + "\t\tStatement stmt=null;";
  protected final String TEXT_2 = NL + "\t\t";
  protected final String TEXT_3 = NL + "\t\t";
  protected final String TEXT_4 = "\t" + NL + "\t}" + NL + "\t" + NL + "\tpublic static void drop(){" + NL + "\t\tStatement stmt=null;";
  protected final String TEXT_5 = NL + "\t\t";
  protected final String TEXT_6 = NL + "\t\t";
  protected final String TEXT_7 = "\t" + NL + "\t}" + NL + "}" + NL + NL;
  protected final String TEXT_8 = NL;

	private ArrayList createStrings=new ArrayList();
	private ArrayList dropStrings=new ArrayList();
	private Registry reg;//forceert behoud van de Map tot na finalize()!!!


	public DBScript(Registry reg){
		this.reg=reg;
	}

	/**
	 * Create scripts for creating and deleting all persistent classes AND persist the TableComponent hierarchies. 
	 * @see java.lang.Object#finalize()
	 */
	public void generate(){
		//maak een Script-klasse met static methoden create en drop en parameter _d_i_a_l_e_c_t_ voor dialect
		System.out.println("Bezig met schrijven van Script.java!");
		try {
			File curFile=new File(System.getProperty("user.dir")+System.getProperty("file.separator")+"Script.java");
			PrintWriter writer=new PrintWriter(new BufferedWriter(new FileWriter(curFile)));
			writer.print(generate(null));
			writer.close();
		} catch (IOException e) {
			System.out.println("Problem whilst writing file Script.java!");
			e.printStackTrace();
		}
	}
	
	public void addCreate(String create){
		createStrings.add(create);
	}
	
	public void addDrop(String drop){
		dropStrings.add(drop);
	}
	
	/**
	 * Create scripts for creating and deleting all persistent classes AND persist the TableComponent hierarchies. 
	 * @see java.lang.Object#finalize()
	 */
	protected void finalize() throws Throwable {
		generate();
		super.finalize();
	}
	
    public String generate(Object argument)
  {
    StringBuffer stringBuffer = new StringBuffer();
    stringBuffer.append(TEXT_1);
    
		Iterator it=createStrings.iterator();
		while(it.hasNext()){
    stringBuffer.append(TEXT_2);
    stringBuffer.append( (String)it.next() );
    stringBuffer.append(TEXT_3);
    }
		
    stringBuffer.append(TEXT_4);
    
		it=dropStrings.iterator();
		while(it.hasNext()){
    stringBuffer.append(TEXT_5);
    stringBuffer.append( (String)it.next() );
    stringBuffer.append(TEXT_6);
    }			
		
    stringBuffer.append(TEXT_7);
    stringBuffer.append(TEXT_8);
    return stringBuffer.toString();
  }
}