<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:xalan="http://xml.apache.org/xalan"
                xmlns:java="http://xml.apache.org/xalan/java"
                extension-element-prefixes="java"
                exclude-result-prefixes="java"
                version="1.0"
>
  <xsl:output method="text"/> 
   <!--XSLT-bestand voor generatie implementor-aspecten.-->
  <xsl:template match="/">
  <xsl:text>
	package aspects.imp.</xsl:text><xsl:value-of select="java:persistence.Utilities.getPackageName(string(/classUnit[1]/@name))"/><xsl:text>;
  
	import java.io.BufferedInputStream;
	import java.io.FileInputStream;
	import java.io.FileNotFoundException;
	import java.io.IOException;
	import java.io.InputStream;
	import java.sql.SQLException;
	import java.sql.Statement;
	import java.sql.Connection;
	import java.sql.ResultSet;
	import java.util.Properties;
	import java.util.Vector;
	import java.util.Iterator;
	
	import java.lang.reflect.Constructor;
	import java.lang.reflect.InvocationTargetException;
	import java.lang.reflect.Modifier;
	
    import persistence.type.*;
    import com.sun.jdori.common.query.MyMemoryQuery;
    import com.sun.jdori.query.JDOQueryException;
  
  public privileged aspect </xsl:text><xsl:value-of select="java:persistence.Utilities.prepareAspectName(string(/classUnit[1]/@name))"/><xsl:text>{
  </xsl:text>
  	<xsl:apply-templates/>
  <xsl:text>}
</xsl:text>
</xsl:template>
<xsl:template match="/classUnit/persistentClass">
<xsl:variable name="className" select="java:java.lang.String.new(string(@name))"/>
<xsl:variable name="SQLFactory"       
        select="java:persistence.AbstractSQLFactoryImpl.new(.,$className,'connection')"/>
	
	<xsl:value-of select="java:getInsertStatement($SQLFactory)"/>
  	
  	<xsl:value-of select="java:getUpdateStatement($SQLFactory)"/>
  		
  	<xsl:value-of select="java:getDeleteStatement($SQLFactory)"/>
  	
	<xsl:value-of select="java:getReadStatement($SQLFactory)"/>
  		
  	<xsl:value-of select="java:getQueryStatements($SQLFactory)"/>
  	
  	<xsl:value-of select="java:addToScript($SQLFactory)"/>
	
</xsl:template>
</xsl:stylesheet>