<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  version="1.0"
  >
  <xsl:output method="text"/> 
  <!-- XSLT-bestand voor generatie introducer-aspect. -->
  <xsl:template match="/">
  <xsl:text>
	package aspects;
  
	import java.io.BufferedInputStream;
	import java.io.FileInputStream;
	import java.io.FileNotFoundException;
	import java.io.IOException;
	import java.io.InputStream;
	import java.sql.SQLException;
	import java.sql.Connection;
	import java.sql.ResultSet;
	import java.sql.Statement;
	import java.util.Properties;
	import java.util.Vector;
	import java.util.ArrayList;
	import java.util.Collection;
	import java.util.Iterator;
	import net.sf.hibernate.HibernateException;
	import net.sf.hibernate.dialect.Dialect;
	import net.sf.hibernate.sql.Select;
    
	import persistence.DatabaseConnection;
    import persistence.type.*;
    import persistence.Utilities;
    import com.sun.jdori.common.query.MyMemoryQuery;
    
    import persistence.exceptions.DeleteException;
	import persistence.exceptions.UpdateException;
	import persistence.exceptions.WriteException;
	
	import persistence.transaction.Transaction;
  
  
  public privileged aspect PersistenceIntroducer{


  </xsl:text>
  <xsl:apply-templates/>
  <xsl:text>
	private static ObjectIDFactory fab=new ObjectIDFactory();  
  	private ObjectID Persistent.OID=fab.getObjectID(this);
  	
  	public ObjectID Persistent.getOID(){
  		return OID;
  	}
  	
	public void Persistent.setOID(ObjectID ob){
		OID=ob;
	}  	
  	
	public void Persistent.write() throws WriteException{}
  	
	public void Persistent.update() throws UpdateException{}
  	
  	public void Persistent.delete() throws DeleteException{}  
  	
  	public void Persistent.write(Transaction trans) throws WriteException{write();}
  	
	public void Persistent.update(Transaction trans) throws UpdateException{update();}
  	
	public void Persistent.delete(Transaction trans) throws DeleteException{delete();}
	
	private String ObjectID.cClass="";
  	
	/**
    * Get indication of current class of object with this ObjectID, depending on position in inheritance tree.
	* @return Indication of class of object with this ObjectID	 
	*/
	public String ObjectID.getCClass(){
		return cClass;
	}
	
    /**
	* Adjust current class of object.
	*/
	public void ObjectID.setCClass(String ccClass){
		cClass=ccClass;
	}
	
	pointcut IDConstructor(ObjectID OID,String claName):this(OID)&amp;&amp;((execution(ObjectID+.new(String))&amp;&amp;args(claName))||(execution(ObjectID+.new(..,String))&amp;&amp;args(..,claName)));
	
	declare error:call(public * ObjectID+.*etCClass(..))&amp;&amp;!within(aspects..*):"g/setCClass(..) mag je niet gebruiken buiten aspects-package!";
	
	after(ObjectID OID,String claName):IDConstructor(OID,claName){
		OID.cClass=claName;
	}
	
	public int Persistent.hashCode(){
		return OID.hashCode();  	
	}

	//nuttige pointcuts  	
		public pointcut writedeleteupdate():execution(public void persistence.type.Persistent.write() throws persistence.exceptions.WriteException)
	||execution(public void persistence.type.Persistent.delete() throws persistence.exceptions.DeleteException)
	||execution(public void persistence.type.Persistent.update() throws persistence.exceptions.UpdateException);
	
	public pointcut read():execution(public static Object persistence.type.Persistent.QueryManager.read(ObjectID,..));
	
	public pointcut walk():call(
	public Object com.sun.jdori.query.TreeWalker.walk(
		com.sun.jdori.query.Node,
		com.sun.jdori.query.NodeVisitor+));
	
	public pointcut implementorAdvice():adviceexecution()&amp;&amp;within(aspects.imp..*);
	
	public pointcut persistentExecution():(writedeleteupdate()||read()||walk())&amp;&amp;!cflow(implementorAdvice());//adviceexecution());
	
	public pointcut twritedeleteupdate(persistence.transaction.Transaction trans):(execution(public void persistence.type.Persistent.write(persistence.transaction.Transaction) throws persistence.exceptions.WriteException)
||execution(public void persistence.type.Persistent.delete(persistence.transaction.Transaction) throws persistence.exceptions.DeleteException)
||execution(public void persistence.type.Persistent.update(persistence.transaction.Transaction) throws persistence.exceptions.UpdateException))&amp;&amp;args(trans);
	
	public pointcut tread(persistence.transaction.Transaction trans):execution(public static Object persistence.type.Persistent.QueryManager.read(persistence.transaction.Transaction,..))&amp;&amp;args(trans,..);
	
	public pointcut tpersistentExecution(persistence.transaction.Transaction trans):(twritedeleteupdate(trans)||tread(trans))&amp;&amp;!cflow(PersistenceIntroducer.implementorAdvice());//adviceexecution());

  }  	
  </xsl:text> 
  </xsl:template>

  <xsl:template match="/root/classUnit/class">
    <xsl:text>declare parents: </xsl:text><xsl:apply-templates select="text()"/><xsl:text> implements Persistent;</xsl:text>
  </xsl:template>
  
   <xsl:template match="/root/classUnit/interface">
   <xsl:text>declare parents: </xsl:text><xsl:apply-templates select="text()"/><xsl:text> implements Persistent;</xsl:text>
  </xsl:template>
</xsl:stylesheet>


