/*
 * Created on 6-mrt-2004
 *
*/
package javapro;

import java.sql.Date;
import java.util.HashSet;

/**
 * @author bram
 * @persistent
 * @pversion major="01"
 *
 * 6-mrt-2004
 */
public class Employee {
	/**
	 * @persistent
	 * @accessor
	 */
	private long        empid;
	
	/**
	 * @persistent
	 * @accessor
	 */
	private String      firstname;
	
	/**
	 * @persistent
	 * @accessor
	 */
	private String      lastname;
	
	/**
	 * @persistent contained="uni"
	 * @accessor
	 */
	private Address     address;
	
	/**
	 * @persistent
	 * @accessor
	 */
	private String        birthdate;
	
	/**
	 * @persistent
	 * @accessor
	 */
	private String        hiredate;
	
	/**
	 * @persistent
	 * @accessor
	 */
	private float       salary;
	
	/**
	 * @persistent contained="false"
	 * @accessor
	 */
	private Department  department;
	
	/**
	 * @persistent contained="false"
	 * @accessor
	 */
	private Employee    manager;
	
	/**
	 * @persistent
	 * @accessor
	 * @content compType="javapro.Project" contained="false"
	 */
	private HashSet     projects;//element:Project
	
	public Employee(){
		empid=0L;
		firstname="";
		lastname="";
		address=null;
		birthdate=null;
		hiredate=null;
		salary=0F;
		department=null;
		manager=null;
		projects=null;//element:Project
	}
	
	
	/**
	 * @return
	 */
	public Address getAddress() {
		return address;
	}

	/**
	 * @return
	 */
	public String getBirthdate() {
		return birthdate;
	}

	/**
	 * @return
	 */
	public Department getDepartment() {
		return department;
	}

	/**
	 * @return
	 */
	public long getEmpid() {
		return empid;
	}

	/**
	 * @return
	 */
	public String getFirstname() {
		return firstname;
	}

	/**
	 * @return
	 */
	public String getHiredate() {
		return hiredate;
	}

	/**
	 * @return
	 */
	public String getLastname() {
		return lastname;
	}

	/**
	 * @return
	 */
	public Employee getManager() {
		return manager;
	}

	/**
	 * @return
	 */
	public HashSet getProjects() {
		return projects;
	}

	/**
	 * @return
	 */
	public float getSalary() {
		return salary;
	}

	/**
	 * @param address
	 */
	public void setAddress(Address address) {
		this.address = address;
	}

	/**
	 * @param date
	 */
	public void setBirthdate(String date) {
		birthdate = date;
	}

	/**
	 * @param department
	 */
	public void setDepartment(Department department) {
		this.department = department;
	}

	/**
	 * @param l
	 */
	public void setEmpid(long l) {
		empid = l;
	}

	/**
	 * @param string
	 */
	public void setFirstname(String string) {
		firstname = string;
	}

	/**
	 * @param date
	 */
	public void setHiredate(String date) {
		hiredate = date;
	}

	/**
	 * @param string
	 */
	public void setLastname(String string) {
		lastname = string;
	}

	/**
	 * @param employee
	 */
	public void setManager(Employee employee) {
		manager = employee;
	}

	/**
	 * @param set
	 */
	public void setProjects(HashSet set) {
		projects = set;
	}

	/**
	 * @param f
	 */
	public void setSalary(float f) {
		salary = f;
	}

}
