/*
 * Created on 24-okt-2003
 *
*/
package persistence.table;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import persistence.visitor.TableComponentVisitor;

/**
 * Table for an "array". All dimensions in one big table!!!
 * @author bram
 *
 * 24-okt-2003
 */
public class ArrayTable extends Table {

	/**
	 * Creates Table with D+1 key attributes called "refOID" and "$positionX$" (X=1->D) where D=dimension of array. The
	 * compType is really the compType: NO "[]"'s!!!
	 */
	public ArrayTable(int dimension) {
		super("$refOID$");
		addProperty("dimension", String.valueOf(dimension));

		for (int i = 1; i <= dimension; i++) {
			TableComponent position = new Attribute();
			position.addProperty("key", "true");
			position.setComponentName("POSITION" + i + "");
			position.setJavaTypeName("int");
			position.addProperty("get", "?");
			position.addProperty("set", "?");
			add(position);
		}
	}

	public ArrayTable(Collection FKeys, int dimension) {
		super(FKeys);
		addProperty("dimension", String.valueOf(dimension));

		for (int i = 1; i <= dimension; i++) {
			TableComponent position = new Attribute();
			position.addProperty("key", "true");
			position.setComponentName("POSITION" + i + "");
			position.setJavaTypeName("int");
			position.addProperty("get", "?");
			position.addProperty("set", "?");
			add(position);
		}
	}

	/**
	 * @see persistence.TableComponent#accept(persistence.TableComponentVisitor)
	 */
	public void accept(TableComponentVisitor visitor) {
		visitor.visitArrayTable(this);
	}

}
