/*
 * Created on 23-okt-2003
 *
*/
package persistence.table;

import persistence.visitor.TableComponentVisitor;

/**
 * This class has same functionality as TableComponent, but represents "attribute"-column.
 * @author bram
 *
 * 23-okt-2003
 */
public class Attribute extends TableComponent {

	/**
	 * Function is attribute.
	 */
	public Attribute() {
		super();
	}

	/**
	 * @see persistence.TableComponent#accept(persistence.TableComponentVisitor)
	 */
	public void accept(TableComponentVisitor visitor) {
		visitor.visitAttribute(this);

	}

	/**
	 * Default value provided for "key"-key.
	 * @see persistence.table.TableComponent#getProperty(java.lang.String)
	 */
	public String getProperty(String key) {
		String res = super.getProperty(key);
		if (res == null) {
			if (key.equals("key")) {
				res = "false";
			} else {
				if (key.equals("FK")) {
					res = "false";
				}
			}
		}
		return res;
	}

}
