/*
 * Created on 25-okt-2003
 *
*/
package persistence.table;

import persistence.visitor.TableComponentVisitor;

/**
 * Attribute which contains OID-String representation of another persistent Object.
 * @author bram
 *
 * 25-okt-2003
 */
public class ReferenceAttribute extends Attribute {

	/**
	 * 
	 */
	public ReferenceAttribute() {
		super();
	}

	/**
	 * @see persistence.TableComponent#accept(persistence.TableComponentVisitor)
	 */
	public void accept(TableComponentVisitor visitor) {
		visitor.visitReferenceAttribute(this);

	}

	/**
	 * @see persistence.table.TableComponent#getProperty(java.lang.String)
	 */
	public String getProperty(String key) {
		String res = super.getProperty(key);
		if (res == null) {
			if (key.startsWith("contained")) {
				res = "false";
			} else if (key.startsWith("isInterface")) {
				res = "false";
			} else if (key.startsWith("isAbstract")) {
				res = "false";
			}
		}
		return res;
	}

}
