/*
 * Created on 23-okt-2003
 *
*/
package persistence.table;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import persistence.visitor.TableComponentVisitor;

/**
 * Stelt een tabel voor.
 * @author bram
 *
 * 23-okt-2003
 */
public class Table extends TableComponent {
	private List attributes; //geordend=>keys vooraan!!!

	/**
	 * Creates Table with 1 key attribute called "OID". This has length of OIDLength.
	 */
	public Table() {
		super();
		attributes = new ArrayList();
		TableComponent OID = new Attribute();
		OID.addProperty("key", "true");
		OID.setComponentName("OID");
		OID.setJavaTypeName("java.lang.String");
		OID.addProperty("size", String.valueOf(OIDLength));
		OID.addProperty("get", "getOID");
		OID.addProperty("set", "setOID");
		OID.addProperty("accessor", "true");
		OID.addProperty("index", "true");
		add(OID);
	}

	/**
	 * Creates Table with 1 key attribute called OIDName. This has length of OIDLength.
	 * @param OIDName
	 */
	protected Table(String OIDName) {
		super();
		attributes = new ArrayList();
		TableComponent OID = new Attribute();
		OID.addProperty("key", "true");
		OID.setComponentName(OIDName);
		OID.setJavaTypeName("java.lang.String");
		OID.addProperty("size", String.valueOf(OIDLength));
		OID.addProperty("get", "getOID");
		OID.addProperty("set", "setOID");
		OID.addProperty("accessor", "true");
		add(OID);
	}

	protected Table(Collection FKeys) {
		super();
		attributes = new ArrayList(FKeys);
	}

	/**
	 * 
	 * @see persistence.TableComponent#add(persistence.TableComponent)
	 */
	public void add(TableComponent t) {
		attributes.add(t);
	}

	/**
	 * 
	 * @see persistence.TableComponent#remove(persistence.TableComponent)
	 */
	public void remove(TableComponent t) {
		attributes.remove(t);
	}

	/**
	 * 
	 * @see persistence.TableComponent#getChildren()
	 */
	public List getChildren() {
		return attributes;
	}

	/**
	 * @see persistence.TableComponent#isLeaf()
	 */
	public boolean isLeaf() {
		return false;
	}

	/**
	 * @see persistence.TableComponent#accept(persistence.TableComponentVisitor)
	 */
	public void accept(TableComponentVisitor visitor) {
		visitor.visitTable(this);

	}

	/**
	 * @see persistence.table.TableComponent#getProperty(java.lang.String)
	 */
	public String getProperty(String key) {
		String res = super.getProperty(key);
		if (res == null) {
			if (key.equals("extends")) {
				res = "java.lang.Object";
			} else if (key.equals("minor")) {
				res = "0";
			} else if (key.equals("root")) {
				res = "false";
			}
		}
		return res;
	}

}
