/*
 * Created on 10-apr-2004
 *
*/
package persistence.transaction;

/**
 * Vereist gedrag voor supertransactie-objecten.
 * @author bram
 *
 * 10-apr-2004
 */
public interface Transaction {
	/**
	 * Unique transaction ID.
	 * @return
	 */
	public String getTransactionID();

	/**
	 * Commit transaction (do nothing if not active).
	 *
	 */
	public void commit();

	/**
	 * Start transaction (commits if already begun).
	 *
	 */
	public void start();

	/**
	 * Rollback transaction (do nothing if not active).
	 *
	 */
	public void rollback();

	/**
	 * Check whether transaction has started yet.
	 *
	 */
	public boolean isActive();
}
