/*
 * Created on 26-apr-2003 
*/
package persistence.type;

import java.util.Date;

/**
 * Unique ID across all persistent objects.
 * @author bram
 *
 *26-apr-2003 
*/
public interface ObjectID extends Comparable {
	
	/**
	 * Get indication of actual class of object with this ObjectID, fixed at creation.
	 * @return Indication of class of object with this ObjectID
	 
	*/
	public String getAClass();
	

	/**
	 * Get timestamp
	 * @return timestamp
	*/
	public Date getTime();

	/**
	 * Get IP address
	 * @return IP address		 
	*/
	public String getIp();

	/**
	 * String representation of ObjectID
	 * @return String representation of ObjectID		 
	*/
	public String toString();
	
	
}
