/*
 * Created on 12-okt-2003
*/
package persistence.type;

import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import javax.jdo.Query;

import persistence.exceptions.DeleteException;
import persistence.exceptions.UpdateException;
import persistence.exceptions.WriteException;
import persistence.transaction.Transaction;
import persistence.transaction.TransactionImpl;

import com.sun.jdori.common.query.MyQueryImpl;

/**
 * Interface waarvan @persistent-klassen via ITD implementors worden. De uitgebreide versie
 * wordt hier gegeven (Transaction-support).
 * @author bram
 *
 * 12-okt-2003
 */
public interface Persistent {
	public void write() throws WriteException;
	public void update() throws UpdateException;
	public void delete() throws DeleteException;

	public void write(Transaction trans) throws WriteException;
	public void update(Transaction trans) throws UpdateException;
	public void delete(Transaction trans) throws DeleteException;

	public static class QueryManager {

		public static Object read(ObjectID OID, boolean deep) {
			return null;
		}

		public static Vector read(Collection OIDs, boolean deep) {
			Vector res = new Vector();
			Iterator it = OIDs.iterator();
			while (it.hasNext()) {
				res.add(read((ObjectID) it.next(), deep));
			}
			return res;
		}

		public static javax.jdo.Query newQuery() {
			return new MyQueryImpl(null);
		}

		public static javax.jdo.Query newQuery(java.lang.Class cls) {
			return new MyQueryImpl(null, cls);
		}

		public static javax.jdo.Query newQuery(
			java.lang.Class cls,
			java.util.Collection cln) {
			return new MyQueryImpl(null, cls, cln);
		}

		public static javax.jdo.Query newQuery(
			java.lang.Class cls,
			java.util.Collection cln,
			java.lang.String filter) {
			return new MyQueryImpl(null, cls, cln, filter);
		}

		public static javax.jdo.Query newQuery(
			java.lang.Class cls,
			java.lang.String filter) {
			return new MyQueryImpl(null, cls, filter);
		}

		public static Transaction newTransaction() {
			return new TransactionImpl();
		}

		public static Object read(
			Transaction trans,
			ObjectID OID,
			boolean deep) {
			return read(OID, deep);
		}

	}
}
