package tests;
import junit.framework.TestCase;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;

import persistence.exceptions.DeleteException;
import persistence.exceptions.WriteException;
import persistence.type.ObjectID;
import persistence.type.Persistent;

import testApp.ChildPersistentClass;
import testApp.PersistentClass;
import testApp.PrimitiveClass;


/*
 * Created on 27-feb-2004
 *
*/

/**
 * @author bram
 *
 * 27-feb-2004
 */
public class ChildPersistentClassTest extends TestCase {
	private ChildPersistentClass pers1;
	private ObjectID OID;

	/**
	 * Constructor for ChildPersistentClassTest.
	 * @param arg0
	 */
	public ChildPersistentClassTest(String arg0) {
		super(arg0);
	}

	public void testRead(){
		System.out.println("#ChildPersistentClassTest: start testRead()");
		OID=pers1.getOID();
		Object o=Persistent.QueryManager.read(OID,true);
		//System.out.println(o.getClass().getName());
		ChildPersistentClass pe1=(ChildPersistentClass)o;//pers1 is het andere!
		Iterator itPers1=pers1.getAr().iterator();
		Iterator itPe1=pe1.getAr().iterator();
		while(itPers1.hasNext()){
			Map mapPers1=(Map)itPers1.next();
			Map mapPe1=(Map)itPe1.next();
			Iterator itPers1Map=mapPers1.keySet().iterator();
			Iterator itPe1Map=mapPe1.keySet().iterator();
			while(itPers1Map.hasNext()){
				String strPers1=(String)itPers1Map.next();
				String strPe1=(String)itPe1Map.next();
				assertEquals(strPers1,strPe1);
				Collection collPers1=(Collection)mapPers1.get(strPers1);
				Collection collPe1=(Collection)mapPe1.get(strPe1);
				Iterator itPers1Coll=collPers1.iterator();
				Iterator itPe1Coll=collPe1.iterator();
				while(itPers1Coll.hasNext()){
					assertEquals(((Integer)itPers1Coll.next()).intValue(),((Integer)itPe1Coll.next()).intValue());
				}
			}
		}
		int[] rij3=pers1.getIn();
		int[] rij4=pe1.getIn();
		for(int i=0;i<rij3.length;i++){
			assertEquals(rij3[i],rij4[i]);
		}
		//extra attribuut (niet overgerfd)
		assertEquals(pers1.getNotInherited(),pe1.getNotInherited());
		System.out.println("#ChildPersistentClassTest: einde testRead()");
	}

	/*
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		System.out.println("#ChildPersistentClassTest: start setup");
		super.setUp();
		pers1=new ChildPersistentClass();
		ArrayList ar1=new ArrayList();
		Collection coll1=new ArrayList();
		coll1.add(new Integer(1));
		coll1.add(new Integer(321));
		Map map1=new HashMap();
		map1.put("eerste",coll1);
		ar1.add(map1);
		pers1.notOrdinarySetter(ar1);		
		pers1.setIn(new int[2]);
		pers1.setNotPers(56);
		pers1.setNotInherited(156);
		System.out.println("#ChildPersistentClassTest: write pers1");
		try{
			pers1.write();
		}catch(WriteException ex){
			ex.printStackTrace();
		}
		System.out.println("#ChildPersistentClassTest: einde setup");
	}

	/*
	 * @see TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		System.out.println("#ChildPersistentClassTest: start teardown");
		try{
			pers1.delete();
		}catch(DeleteException ex){
			ex.printStackTrace();
		}
		super.tearDown();
		System.out.println("#ChildPersistentClassTest: einde teardown");
	}
	
	public static void main(String[] args){
		ChildPersistentClass pers1=new ChildPersistentClass();
		//PersistentClass pers1=new PersistentClass();
		ArrayList ar1=new ArrayList();
		Collection coll1=new ArrayList();
		coll1.add(new Integer(1));
		coll1.add(new Integer(321));
		Map map1=new HashMap();
		map1.put("eerste",coll1);
		ar1.add(map1);
		pers1.notOrdinarySetter(ar1);		
		pers1.setIn(new int[2]);
		pers1.setNotPers(56);
		//ChildPersistentClass tmp=(ChildPersistentClass)pers1;
		pers1.setNotInherited(156);
		try{
			pers1.write();
		}catch(WriteException ex){
			ex.printStackTrace();
		}
		
		//test
		ObjectID OID=pers1.getOID();
		ChildPersistentClass pe1=(ChildPersistentClass)Persistent.QueryManager.read(OID,true);//pers1 is het andere!
		Iterator itPers1=pers1.getAr().iterator();
		Iterator itPe1=pe1.getAr().iterator();
		while(itPers1.hasNext()){
			Map mapPers1=(Map)itPers1.next();
			Map mapPe1=(Map)itPe1.next();
			Iterator itPers1Map=mapPers1.keySet().iterator();
			Iterator itPe1Map=mapPe1.keySet().iterator();
			while(itPers1Map.hasNext()){
				String strPers1=(String)itPers1Map.next();
				String strPe1=(String)itPe1Map.next();
				assertEquals(strPers1,strPe1);
				Collection collPers1=(Collection)mapPers1.get(strPers1);
				Collection collPe1=(Collection)mapPe1.get(strPe1);
				Iterator itPers1Coll=collPers1.iterator();
				Iterator itPe1Coll=collPe1.iterator();
				while(itPers1Coll.hasNext()){
					assertEquals(((Integer)itPers1Coll.next()).intValue(),((Integer)itPe1Coll.next()).intValue());
				}
			}
		}
		int[] rij3=pers1.getIn();
		int[] rij4=pe1.getIn();
		for(int i=0;i<rij3.length;i++){
			assertEquals(rij3[i],rij4[i]);
		}
		//extra attribuut (niet overgerfd)
		assertEquals(pers1.getNotInherited(),pe1.getNotInherited());
		
		
		//opkuis
		try{
			pers1.delete();
		}catch(DeleteException ex){
			ex.printStackTrace();
		}
		
		
	}

}
