package tests;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;

import persistence.exceptions.DeleteException;
import persistence.exceptions.WriteException;
import persistence.type.ObjectID;
import persistence.type.Persistent;

import testApp.PersistentClass;
import testApp.PrimitiveClass;
import junit.framework.TestCase;

/*
 * Created on 4-nov-2003
 *
*/

/**
 * @author bram
 *
 * 4-nov-2003
 */
public class PrimitiveClassTest extends TestCase {
	private PrimitiveClass prim;
	private PersistentClass pers1;
	private PersistentClass pers2;
	private PersistentClass pers3;
	private ObjectID OID;

	/**
	 * Constructor for PrimitiveClassTest.
	 * @param arg0
	 */
	public PrimitiveClassTest(String arg0) {
		super(arg0);
	}

	/*public void testUpdate(){
		System.out.println("UPUPUP0UPUPUPUPUPUPUPUPPUPP");		
		ArrayList ar3=new ArrayList();
		Collection coll3=new ArrayList();		
		coll3.add(new Integer(2031));
		coll3.add(new Integer(1));
		Map map3=new HashMap();
		map3.put("vierde",coll3);
		ar3.add(map3);
		pers3.setAr(ar3);		
		pers3.setIn(new int[10]);
		pers3.setNotPers(6);
		pers3.update();
	}*/
	
	public void testRead(){
		System.out.println("#PrimitiveClassTest: start testRead()");
		//System.err.println("prim: "+prim.getOID());
		PrimitiveClass readin=(PrimitiveClass)Persistent.QueryManager.read(OID,true);
		//System.out.println("readin: "+readin.getOID());
		assertEquals(prim.getOID(),readin.getOID());//zelfde OIDs
		assertEquals(prim.getAWeirdDouble(),readin.getAWeirdDouble(),0.0);
		//System.out.println("floats: prim "+prim.getAFloat()+" readin "+readin.getAFloat());
		//de float is NIET persistent!!!
		//assertEquals(prim.getAFloat().doubleValue(),readin.getAFloat().doubleValue(),0.0);
		assertEquals(prim.getAnInt(),readin.getAnInt());
		assertEquals(prim.getAString(),readin.getAString());
		int[][][][] rij1=prim.getDrieD();
		int[][][][] rij2=readin.getDrieD();
		for (int i = 0; i < rij1.length; i++) {
			for (int j = 0; j < rij1[i].length; j++) {
				for (int k = 0; k < rij1[i][j].length; k++) {
					for (int index = 0; index < rij1[i][j][k].length; index++) {
						assertEquals(rij1[i][j][k][index],rij2[i][j][k][index]);
					}
				}
			}
		}
		
		//testen van persObj
		PersistentClass pe1=readin.getPersObj();//pers1 is het andere!
		assertEquals(pers1.getInn().getJ(),pe1.getInn().getJ());
		Iterator itPers1=pers1.getAr().iterator();
		Iterator itPe1=pe1.getAr().iterator();
		while(itPers1.hasNext()){
			Map mapPers1=(Map)itPers1.next();
			Map mapPe1=(Map)itPe1.next();
			Iterator itPers1Map=mapPers1.keySet().iterator();
			Iterator itPe1Map=mapPe1.keySet().iterator();
			while(itPers1Map.hasNext()){
				String strPers1=(String)itPers1Map.next();
				String strPe1=(String)itPe1Map.next();
				assertEquals(strPers1,strPe1);
				Collection collPers1=(Collection)mapPers1.get(strPers1);
				Collection collPe1=(Collection)mapPe1.get(strPe1);
				Iterator itPers1Coll=collPers1.iterator();
				Iterator itPe1Coll=collPe1.iterator();
				while(itPers1Coll.hasNext()){
					assertEquals(((Integer)itPers1Coll.next()).intValue(),((Integer)itPe1Coll.next()).intValue());
				}
			}
		}
		int[] rij3=pers1.getIn();
		int[] rij4=pe1.getIn();
		for(int i=0;i<rij3.length;i++){
			assertEquals(rij3[i],rij4[i]);
		}
		
		//testen van coll
		itPers1=prim.getColl().iterator();
		itPe1=readin.getColl().iterator();
		while(itPers1.hasNext()){
			Collection pers1Coll=(Collection)itPers1.next();
			Collection pe1Coll=(Collection)itPe1.next();
			Iterator itPers1Coll=pers1Coll.iterator();
			Iterator itPe1Coll=pe1Coll.iterator();
			while(itPers1Coll.hasNext()){
				PersistentClass perso=(PersistentClass)itPers1Coll.next();
				PersistentClass pee1=(PersistentClass)itPe1Coll.next();
				assertEquals(perso.getInn().getJ(),pee1.getInn().getJ());
				//System.err.println("perso: "+perso.getOID()+" <-> pee1: "+pee1.getOID());
				Iterator itPeers1=perso.getAr().iterator();
				Iterator itPee1=pee1.getAr().iterator();
				while(itPeers1.hasNext()){
					Map mapPers1=(Map)itPeers1.next();
					Map mapPe1=(Map)itPee1.next();
					Iterator itPeers1Map=mapPers1.keySet().iterator();
					Iterator itPee1Map=mapPe1.keySet().iterator();
					while(itPeers1Map.hasNext()){
						String strPers1=(String)itPeers1Map.next();
						String strPe1=(String)itPee1Map.next();
						assertEquals(strPers1,strPe1);
						Collection collPers1=(Collection)mapPers1.get(strPers1);
						Collection collPe1=(Collection)mapPe1.get(strPe1);
						Iterator itPeers1CollColl=collPers1.iterator();
						Iterator itPee1CollColl=collPe1.iterator();
						while(itPeers1CollColl.hasNext()){
							assertEquals(((Integer)itPeers1CollColl.next()).intValue(),((Integer)itPee1CollColl.next()).intValue());
						}
					}
				}
				int[] rij33=perso.getIn();
				int[] rij44=pee1.getIn();
				for(int i=0;i<rij33.length;i++){
					assertEquals(rij33[i],rij44[i]);
				}		
			}
			System.out.println("OK");
		}
		
		//test map
		Map itPers1Map=prim.getMap();
		Map itPe1Map=readin.getMap();
		itPers1=itPers1Map.keySet().iterator();
		itPe1=itPe1Map.keySet().iterator();
		while(itPers1.hasNext()){
			Double itPers1Do=(Double)itPers1.next();
			Double itPe1Do=(Double)itPe1.next();
			assertEquals(itPers1Do.doubleValue(),itPe1Do.doubleValue(),0.0);
			int[][] rij11=(int[][])itPers1Map.get(itPers1Do);
			int[][] rij22=(int[][])itPe1Map.get(itPe1Do);
			for(int i=0;i<rij11.length;i++){
				for(int j=0;j<rij11[i].length;j++){
					assertEquals(rij11[i][j],rij22[i][j]);
				}
			}
		}
		System.out.println("#PrimitiveClassTest: einde testRead()");
		
	}

	/*
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		System.out.println("#PrimitiveClassTest: start setup"); 
		super.setUp();
		prim=new PrimitiveClass();
		OID=prim.getOID();
		prim.setADouble(5.0);
		prim.setAFloat(new Float(2.3F));
		prim.setAnInt(1);
		prim.setAWeirdString("hallo");
		int[][][][] rij=new int[2][5][1][3];
		for (int i = 0; i < rij.length; i++) {
			for (int j = 0; j < rij[i].length; j++) {
				for (int k = 0; k < rij[i][j].length; k++) {
					for (int index = 0; index < rij[i][j][k].length; index++) {
						rij[i][j][k][index]=i*j-k*index;
					}
				}
			}
		}
		prim.setDrieD(rij);
		pers1=new PersistentClass();
		ArrayList ar1=new ArrayList();
		Collection coll1=new ArrayList();
		coll1.add(new Integer(1));
		coll1.add(new Integer(321));
		Map map1=new HashMap();
		map1.put("eerste",coll1);
		ar1.add(map1);
		pers1.notOrdinarySetter(ar1);		
		pers1.setIn(new int[2]);
		pers1.setNotPers(56);
		PersistentClass.PersistentInnerClass p1=pers1.new PersistentInnerClass();
		p1.setJ(15);
		pers1.setInn(p1);		
		prim.setPersObj(pers1);
		
		pers2=new PersistentClass();
		ArrayList ar2=new ArrayList();
		Collection coll2=new ArrayList();
		coll2.add(new Integer(0));
		Map map2=new HashMap();
		map2.put("tweede",coll2);
		ar2.add(map2);
		pers2.notOrdinarySetter(ar2);		
		pers2.setIn(new int[22]);
		pers2.setNotPers(6);
		PersistentClass.PersistentInnerClass p2=pers2.new PersistentInnerClass();
		p2.setJ(115);
		pers2.setInn(p2);
		
		pers3=new PersistentClass();
		ArrayList ar3=new ArrayList();
		Collection coll3=new ArrayList();		
		coll3.add(new Integer(31));
		Map map3=new HashMap();
		map3.put("derde",coll3);
		ar3.add(map3);
		pers3.notOrdinarySetter(ar3);		
		pers3.setIn(new int[1]);
		pers3.setNotPers(566);
		PersistentClass.PersistentInnerClass p3=pers3.new PersistentInnerClass();
		p3.setJ(1115);
		pers3.setInn(p3);
		
		Collection coll4=new ArrayList();
		Collection coll5=new HashSet();
		coll5.add(pers2);
		coll5.add(pers3);
		coll4.add(coll5);
		prim.setColl(coll4);
		
		int[][] rij1=new int[2][3];
		for(int i=0;i<2;i++){
			for(int j=0;j<3;j++){
				rij1[i][j]=2;
			}
		}
		
		int[][] rij2=new int[12][3];
				for(int i=0;i<12;i++){
					for(int j=0;j<3;j++){
						rij2[i][j]=25;
					}
				}
		map3=new HashMap();
		map3.put(new Double(5.3),rij1);
		map3.put(new Double(25.6),rij2);
		prim.setMap(map3);
		
		System.out.println("#PrimitiveClassTest: write pers1");	
		try{	
			pers1.write();//niet contained!!!
		}catch(WriteException ex){
			ex.printStackTrace();
		}
		System.out.println("#PrimitiveClassTest: write pers2");
		try{		
			pers2.write();//niet contained!!!
		}catch(WriteException ex){
			ex.printStackTrace();
		}
		System.out.println("#PrimitiveClassTest: write pers3");
		try{
			pers3.write();//niet contained!!!
		}catch(WriteException ex){
			ex.printStackTrace();
		}
		System.out.println("#PrimitiveClassTest: write prim");
		try{
			prim.write();
		}catch(WriteException ex){
			ex.printStackTrace();
		}
		System.out.println("#PrimitiveClassTest: einde setup");
	}

	/*
	 * @see TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		System.out.println("#PrimitiveClassTest: start teardown");
		try{
			prim.delete();
			pers3.delete();
			pers2.delete();
			pers1.delete();
		}catch(DeleteException ex){
			ex.printStackTrace();
		}
		super.tearDown();
		System.out.println("#PrimitiveClassTest: einde teardown");
	}

}
